//
//       cvFindContours()
//
// http://robocraft.ru
//

#include <cv.h>
#include <highgui.h>
#include <stdlib.h>
#include <stdio.h>

IplImage* image = 0;
IplImage* gray = 0;
IplImage* bin = 0;
IplImage* dst = 0;

int main(int argc, char* argv[])
{
	//     
	char* filename = argc >= 2 ? argv[1] : "Image0.jpg";
	//  
	image = cvLoadImage(filename,1);

	printf("[i] image: %s\n", filename);
	assert( image != 0 );

	//   
	gray = cvCreateImage( cvGetSize(image), IPL_DEPTH_8U, 1 );
	bin = cvCreateImage( cvGetSize(image), IPL_DEPTH_8U, 1 );
	// 
	dst = cvCloneImage(image);
	//    
	cvNamedWindow("original",CV_WINDOW_AUTOSIZE);
	cvNamedWindow("binary",CV_WINDOW_AUTOSIZE);
	cvNamedWindow("contours",CV_WINDOW_AUTOSIZE);

	//    
	cvCvtColor(image, gray, CV_RGB2GRAY);

	//   
	cvInRangeS(gray, cvScalar(40), cvScalar(150), bin); // atoi(argv[2])

	CvMemStorage* storage = cvCreateMemStorage(0);
	CvSeq* contours=0;

	//  
	int contoursCont = cvFindContours( bin, storage,&contours,sizeof(CvContour),CV_RETR_LIST,CV_CHAIN_APPROX_SIMPLE,cvPoint(0,0));

	//  
	for(CvSeq* seq0 = contours;seq0!=0;seq0 = seq0->h_next){
		cvDrawContours(dst, seq0, CV_RGB(255,216,0), CV_RGB(0,0,250), 0, 1, 8); //  
	}

	//  
	cvShowImage("original",image);
	cvShowImage("binary", bin);
	cvShowImage("contours", dst);

	//   
	cvWaitKey(0);

	//  
	cvReleaseImage(&image);
	cvReleaseImage(&gray);
	cvReleaseImage(&bin);
	cvReleaseImage(&dst);
	//  
	cvDestroyAllWindows();
	return 0;
}
